# -*- coding: UTF-8 -*-

__revision__ = '$Id: ge_localfiles.py 1568 2011-07-12 20:08:12Z jamesm $'

# Copyright © 2009 Piotr Ożarowski
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published byp
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

# You may use and distribute this software under the terms of the
# GNU General Public License, version 2 or later



#
#
#####  TODO #######
#  check the integrity of the database and sort out the filechooser so that it can add single files
#  sort out the permissions box.  it sets highest age rating when none is available
#  need to update imdb plugin for this
#  set colour of first cell to indicate film status - green - film is viewable, red film path set but no film there, blue film there but no permission, orange - dvd
# 
#  when plugin is initialised, iterate the local_file table and check that paths are valid
#  and set the colour of first cell etc appropriately
#
# currently - doing the file_path_column - do the above at the same time
import sys, os, time
import fnmatch
import re
try:
 	import pygtk
	pygtk.require("2.0")
except:
  	pass
try:
	import glib
	import gtk
  	import gtk.glade
except:
	sys.exit(1)

#griffith imports
from gutils import is_windows_system
import gutils
from plugins.extensions import GriffithExtensionBase as Base
from db.tables import movies
from db import Movie
import db
from sql import GriffithSQL
#from db._objects import *
from add import commit
#sqlalchemy imports
from sqlalchemy import Column, ForeignKey, Sequence, Table
from sqlalchemy.types import String, Integer
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import backref, synonym
import logging
log = logging.getLogger('Griffith')

dec_base = declarative_base()

class GriffithExtension(Base):
	name = 'localfiles'
	description = _('Choose movies on your hard drive and add them to Griffith')
	author = 'James Miller'
	email = 'jsm@??.com'
	version = 1
	api = 1
	enabled = False # disabled by default

	preferences = {'command': {'name': _('Command'),
						'hint': _('Enter the command for your movieplayer'),
						'default': 'mplayer',
						'type': unicode},
					'path_display': {'name': _('Display file path in Griffith'),
						'hint': _('select this to display the file path in Griffith'),
						'default': 'False',
						'type': bool},
					'exclude_from_file_name': {'name': _('Exclude from file name'),
						'hint': _('enter words or phrases to exclude from filenames in the following pattern'),
						'default': '(klaxxon)|(axxo)|(dvdrip)|(xvid)|(ts)|(divx)|(dvd)|(ws)|(widescreen)',
						'type': unicode},
					'permissions': {'name': _('Set File Permissions'),
						'hint': _('Set the permissions of the movie file by the film classification'),
						'default': 'False',
						'type': bool}}
	if is_windows_system():
		preferences['command']['default'] = ''

	toolbar_icon = 'ge_localfiles.png'

	#class variables
	_app = None
	_index = 0
	_sorted_model = None
	_session = None
	_engine = None
	_local_file_table = None
	_permissions_set = None
	_watch_movie_context_item = None
	_file_tree_model = None

	def _on_main_context_activated(self, widget):
		if self._session is not None:
			print "hello from context activated"
			#movie = self._session.query(db.Movie).filter(db.Movie.movie_id == self._app._movie_id).first()
			localfile = self._session.query(local_file).filter(local_file.movieid == self._app._movie_id).first()
			if localfile and localfile._filepath != "":
				self._watch_movie_context_item.set_visible(True)
				#todo check file permission to set the following 
				self._watch_movie_context_item.set_sensitive(True)
			else:
				self._watch_movie_context_item.set_sensitive(False)
				self._watch_movie_context_item.set_visible(False)

	def preference_toggled(self, pref_name, pref_value):
		if pref_name == "path_display":
			self._app.widgets['treeview'].get_column(12).set_visible(bool(pref_value))
		if pref_name == "permissions":
			print "Hello File Permissions"

	def __init__(self, griffith):
		#global variable for local_file table that holds file path information
		global dec_base
		#class variable initialisation
		self._app = griffith
		self._app.movie = None
		self._session = griffith.db.Session()
		self._engine = griffith.db.engine
		dec_base.metadata.reflect(self._engine)
		self._local_file_table = local_file.__table__
		
		#initialise the preferences
		self.set_config_value('command', self.get_config_value('command', self.preferences['command']['default']))
		self.set_config_value('exclude_from_file_name', self.get_config_value('exclude_from_file_name', self.preferences['command']['default']))
		#self.set_config_value('
		#renderer.set_property ('cell-background-set', True)   #change colour when film is local - indicates right click will allow watch
		#renderer.set_property ('cell-background-gdk', gtk.gdk.Color(green=1.0))
		#popup (context menu) item to watch film
		self._watch_movie_context_item = gtk.MenuItem("Watch Movie")
		self._watch_movie_context_item.connect("activate", self._watch_movie)
		self._app.widgets['popups']['main'].insert(self._watch_movie_context_item,5)
		self._app.widgets['popups']['main'].connect("show", self._on_main_context_activated)
		
		#create table for local file details
		conn = self._engine.connect()
		conn.execute('PRAGMA foreign_keys=true')
		if not self._local_file_table.exists(bind=self._engine):
			print "localfile table not exist"
			self._local_file_table.create(bind=self._engine)
		
		# file path column added to griffith treeview window
		# todo get this working and add to preferences dialog
		renderer = gtk.CellRendererText()
		file_path_column = gtk.TreeViewColumn(_('File Path'), renderer, text=12)
		file_path_column.set_name('file_path')
		file_path_column.set_sort_column_id(12)
		file_path_column.set_resizable(True)
		file_path_column.set_reorderable(True)
		if self._app.widgets['treeview'].get_column(12) == None:
			self._app.widgets['treeview'].append_column(file_path_column)
		file_path_column.set_visible(bool(self.get_config_value('path_display')))
		
		# set the filepath model
		self._file_tree_model = gtk.ListStore(str)
		
		#setup the main apps treeview
		rows = self._session.query(local_file).all()
		if rows:
			file_path_column.set_cell_data_func(renderer, self._on_filepath_column_func, self._file_tree_model)
		#if rows:
			#for row in rows:
				#movie_row = self._app.session.query(db.Movie).filter(movies.c.movie_id == row.movie_id).first()
				#for
	
	def _on_filepath_column_func(self, col, cell, tree_model, iter, file_model):
		print "hello"
		s = tree_model.get_string_from_iter(iter)
		print s
		print cell.get_property('text')
		#niter = file_model.get_iter_from_string(s)
		#obj = file_model.set_value(niter, 0)
		#cell.set_property('text', obj)

	#def _on_file_tree_model_append
	def _on_toolbar_icon_clicked(self, widget):
		self.lfchooser = self.local_file_dlg(self._app, self)
	
	#called by context menu to watch the film with the player set in preferences
	def _watch_movie(self, menuitem):
		localfile = self._session.query(local_file).filter(local_file.movieid == self._app._movie_id).first()
		use_shell = True
		command = self.get_config_value('command')
		if is_windows_system():
			use_shell = False # Popen with shell=True doesn't work under windows with spaces in filenames
			if not command:
				import win32api
				log.debug('try ShellExecute with localfile %s' % localfile.filepath)
				win32api.ShellExecute(0, None, localfile.filepath, None, None, 0)
		else:
			# make a sequence results in Popen calls list2cmdline
			command = [command, movie.trailer]
		log.debug(command)
		Popen(command, shell=use_shell)

	class local_file_dlg:
		#class variables
		_signal = None #used as a global variable by the tree
		_app = None #a reference to the griffith object
		_movielist = None #the treestore associated with the treeview
		_treeview = None #the treeview
		_populating = False #set while the treeview is populating
		_cancel = False #boolean set when cancel button is pressed
		_filechooser = None #filechooser reference
		_statusbar = None #statusbar
		_buttonbar = None #reference to the buttonbar of the dialog
		_cancelbutton = None #reference to the cancel button
		_dlgWindow = None #reference to the main window (gtkwidget)
		_movienames = []
		_paths = []
		_filters = None #list of file extension patterns
		_cb_add = gtk.CheckButton("Add")
		_parent = None
		_session = None
		_file_chooser_button = None #an extra widget button for the filechooser
		
		def __init__(self, griffith, parent):
			self._parent = parent
			self._app = griffith
			self._session = self._app.db.Session()
			#glade setup and references
			self.gladefile = griffith.locations['glade'] + "/ge_local_files.glade"
			self.wTree = gtk.glade.XML(self.gladefile, "mainWindow")
			self._dlgWindow = self.wTree.get_widget("mainWindow")
			self._dlgWindow.connect("delete-event", self._on_delete)
			self._dlgWindow.get_window().set_transient_for(self._dlgWindow.get_window())
			self._filechooser = self.wTree.get_widget("local_files_choose_btn")
			self._treeview = self.wTree.get_widget("local_files_treeview")
			self._treeview.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
			self._statusbar = self.wTree.get_widget("statusbar1")
			self._buttonbar = self.wTree.get_widget("hbuttonbox1")
			self._cancelbutton = gtk.Button("Cancel")
			self._cancelbutton.unparent()
			self._cancelbutton.connect("clicked", self._cancel_populate)
			
			#Create our dictionary and connect to it
			dic = {"on_ok_clicked" : self._get_movies_and_quit,
						"PopulateTreeView" : self._populate_tree_view,
						"on_file_chosen" : self._on_file_chosen}
			self.wTree.signal_autoconnect(dic)
			
			#treeview columns
			suggested_name_index = 1
			suggested_year_index = 2
			original_name_index = 3
			path_name_index = 4
			suggested_name_title = "Suggested Movie Name"
			suggested_year_title = "Suggested Movie Year"
			original_name_title = "Original Movie Name"
			path_name_title = "Movie File Path Name"

			#file chooser set up
			dfilter = gtk.FileFilter()
			dfilter.set_name("Movies")
			dfilter.add_mime_type("video/avi")
			dfilter.add_mime_type("video/msvideo")
			dfilter.add_mime_type("video/mpeg")
			dfilter.add_mime_type("video/mp4")
			dfilter.add_mime_type("video/x-matroska")
			dfilter.add_mime_type("video/ogg")
			dfilter.add_mime_type("video/x-m4v")
			dfilter.add_pattern("*.avi")
			dfilter.add_pattern("*.mp4")
			dfilter.add_pattern("*.mkv")
			dfilter.add_pattern("*.ogv")
			dfilter.add_pattern("*.m4v")
			self._filechooser.add_filter(dfilter)
			self._filechooser_button = gtk.Button('Choose File')
			self._filechooser_button.connect('clicked', self._on_file_chosen)
			self._filechooser.set_extra_widget(self._filechooser_button)
			self._filters = "*.avi;*.mp4;*.mkv;*.m4v;*.ogv"

			#the list associated with the treeview
			self._movielist = gtk.ListStore(bool, str, str, str, str)
			self._treeview.set_model(self._movielist)

			#add the columns to the treeview
			self.cell = gtk.CellRendererToggle()
			self.cell.connect("toggled", self._on_toggle, self._movielist)
			self.cell.set_activatable(True)
			self._cb_add.set_visible(True)
			self._cb_add.set_sensitive(True)
			#self._cb_add.connect("toggled", self._on_check_selected)
			col = gtk.TreeViewColumn("Add?", self.cell, active=0)
			col.set_clickable(True)
			col.set_widget(self._cb_add)
			col.connect("clicked", self._on_check_selected)
			#col.set_sort_column_id(0)
			#col.set_resizable(True)
			#col.set_reorderable(True)
			self._treeview.append_column(col)
			self._add_movie_list_column(suggested_name_title, suggested_name_index, True)
			self._add_movie_list_column(suggested_year_title, suggested_year_index, True)
			self._add_movie_list_column(original_name_title, original_name_index, False)
			self._add_movie_list_column(path_name_title, path_name_index, False)
			self._movienames = []
			
		def _on_delete(self, widget, event):
			self._treeview.set_model(None)
			if self._movielist:
				self._movielist.clear()
			self._dlgWindow.destroy()
		
		def _on_file_chosen(self, *args):
			print "hello"
			for widget in self._filechooser:
				if isinstance(widget, gtk.Widget):
					print widget.get_parent()

		def _on_filechooser_show(self, widget, event):
			pass

		#called when the user selects a file or folder from the file chooser button
		def _populate_tree_view(self, widget):
			if self._populating: #hack to stop folder selection from calling this function twice
				self._populating = False
				return
			else:
				self._populating = True
			self._show_cancel_button()
			self._treeview.set_model(None) # Detach model from view
			dirname = widget.get_file().get_path()
			self._statusbar.push(1,dirname)
			if len(dirname):
				if os.path.exists(dirname):
					self._parse_all_files(dirname, self._filters)
					self._set_up_rows()
			self._hide_cancel_button()
			self._treeview.set_model(self._movielist) # Re-attach model to view
			return

		#swap the filechooser button for cancel button while files are added
		def _show_cancel_button(self):
			self._buttonbar.remove(self._filechooser)
			self._buttonbar.pack_start(self._cancelbutton)
			self._buttonbar.reorder_child(self._cancelbutton, 0)
			self._cancelbutton.show()
		
		#replace cancel button with filechooser button
		def _hide_cancel_button(self):
			self._buttonbar.remove(self._cancelbutton)
			self._buttonbar.pack_start(self._filechooser)
			self._buttonbar.reorder_child(self._filechooser, 0)

		def _cancel_populate(self, widget):
			self._cancel = True

		#parses filenames and adds data to liststore
		def _set_up_rows(self):
			date = re.compile(r"\d{4}")
			words = re.compile(r"[^|\W|_].+?(?!')(?=[\W|_])")
			site = re.compile(r"(?P<word>(www).*?((com)|(co.uk)))")
			index = 0
			for n in self._movienames:
				while gtk.events_pending():
					gtk.main_iteration_do(False)
				if self._cancel:
					self._cancel = False
					break
				moviename = ""
				thisdate = date.search(n)
				thisname = site.sub("",n)
				thisname = words.findall(thisname)
				if thisdate is None:
					thisdate = 'no date'
				else:
					thisdate = thisdate.group()
				exclude = re.compile(r"" + self._parent.get_config_value('exclude_from_file_name') + "|" + thisdate,re.I)
				for m in thisname:
					while gtk.events_pending():
						gtk.main_iteration_do(False)
					if self._cancel:
						break
					if exclude.match(m):
						break
					else:
						moviename = moviename + " " + m.capitalize()
				if moviename == "":
					moviename = thisdate
				thistuple = [True, moviename,thisdate,n,self._paths[index]]
				self._movielist.append(thistuple)
				index = index + 1
			return

		#returns all files that match a pattern below a directory from python in a nutshell
		def _parse_all_files(self, root, patterns='*',single_level=False, yield_folders=False):
			patterns = patterns.split(';')
			tempname = ""
			for path, subdirs, files in os.walk(root, True, None, True):
				while gtk.events_pending():
					gtk.main_iteration_do(False)
				if self._cancel:
					self._cancel = False
					break
				if yield_folders:
					files.extend(subdirs)
				files.sort()
				if files != None:
					for name in files:
						while gtk.events_pending():
							gtk.main_iteration_do(False)
							if self._cancel:
								break
						for pattern in patterns:
							while gtk.events_pending():
										gtk.main_iteration_do(False)
										if self._cancel:
											break
							if fnmatch.fnmatch(name, pattern):
								if name != tempname:
									self._paths.append(os.path.join(path, name))
									self._movienames.append(name)
									tempname = name
								break
				if single_level:
					break
			return

		#adds columns to treeview
		def _add_movie_list_column(self, title, columnId, editable):
			cell = gtk.CellRendererText()
			cell.set_property('editable', editable)
			if editable:
				cell.connect("edited", self.on_edit, columnId)
			column = gtk.TreeViewColumn(title, cell, text=columnId)
			column.set_resizable(True)
			column.set_sort_column_id(columnId)
			self._treeview.append_column(column)

		def _on_toggle(self, cell, path, *ignore):
			if path is not None:
				it = self._movielist.get_iter(path)
				self._movielist[it][0] = not self._movielist[it][0]

		def _on_check_selected( self, data):
			self._treeview.get_selection().selected_foreach(self.foreachfunc)

		def foreachfunc(self, treemodel, path, iter):
			self._cb_add.set_active(not treemodel[iter][0])
			treemodel[iter][0] = not treemodel[iter][0]

		def on_edit(self, cell, path, text, col):
			if path is not None:
				self._movielist[path][col] = text
			return

		def _get_movies_and_quit(self, widget):
			self._index = 0
			self._sorted_model = gtk.TreeModelSort(self._movielist)
			self._sorted_model.set_sort_column_id(0, gtk.SORT_DESCENDING)
			try:
				self._add_movies_single_threaded()
			except:
				print "exception!"
				self._tidy_up_and_close()

		def _add_movies_single_threaded(self):
			if self._sorted_model[self._index][0] == 1:
				#self._signal = self._app.treemodel.connect("row-changed", self._inserted_a_row, self._sorted_model[self._index])
				movie_title = self._sorted_model[self._index][1]
				movie_year = self._sorted_model[self._index][2]
				self._app._am_movie_id = None
				self._app._resultswin_process = self._add_movies_single_threaded_callback
				self._app._resultswin_button_pressed_signal = self._on_add_movie_results_button_press_event
				if movie_year == 'no date':
					movie_year = ''
				self._statusbar.push(2,"retrieving " + movie_title + " " + movie_year)
				self._app.widgets['add']['title'].set_text(movie_title + " " + movie_year)
				self._app.widgets['add']['o_title'].set_text(movie_title + " " + movie_year)
				self._signal = int(gutils.find_next_available(self._app.db))
				print "hello signal = " + str(self._signal)
				#self._app.widgets['add']['number'].set_value(self._signal)
				self._app.get_from_web()
				#print "classification = " + str(self._app.movie.classification)
			else:
				self._tidy_up_and_close()

		def _on_add_movie_results_button_press_event(self, widget, event):
			"""add a double click event to add movie results"""
			# TODO: use on_results_select_press_event and its selected_key
			if event.type == gtk.gdk._2BUTTON_PRESS:
				self._add_movies_single_threaded_callback

		def _add_movies_single_threaded_callback(self, *args):
			self._app.populate_dialog_with_results()
			self._app.add_movie_db()
			number = self._session.query(db.Movie).filter(db.Movie.number == self._signal).first()
			if number is not None:
				print number
				print number.movie_id
				lf = local_file(self._sorted_model[self._index][1], self._sorted_model[self._index][4], number.movie_id)
				print lf
				self._session.add(lf)
				commit(self._session)
			#rows = self._session.query(local_file).all()
			#for row in rows:
				#print row
			#if
			#if
			self._index = self._index + 1
			try:
				self._add_movies_single_threaded()
			except:
				self._tidy_up_and_close()

		def _tidy_up_and_close(self):
			self._app._resultswin_process = self._app.populate_dialog_with_results
			self._app._resultswin_button_pressed_signal = self._app.on_add_movie_results_button_press_event
			self._hide_cancel_button()
			self._cancel = True
			self._dlgWindow.destroy()

		def _inserted_a_row(self, model, path, iter, n):
			lf = local_file(n[1], n[4])
			self._app.session.add(lf)
			self._app.commit()
			self._app.treemodel.disconnect(self._signal)
 
class local_file(dec_base):
		__tablename__ = 'local_file'
		_id = Column(Integer, autoincrement=True, primary_key=True)
		_filename = Column(String(50), nullable=False)
		_filepath = Column(String(128), nullable=False)
		_movieid = Column(Integer, ForeignKey(movies.c.movie_id, ondelete='CASCADE'))

		@property
		def filename(self):
			return self._filename

		@filename.setter
		def filename(self, filename):
			self._filename = filename

		@property
		def filepath(self):
			return self._filepath

		@filepath.setter
		def filepath(self, filepath):
			self._filepath = filepath

		@property
		def movieid(self):
			return self._movieid

		@movieid.setter
		def movieid(self, movieid):
			self._movieid = movieid

		@property
		def id(self):
			return self._id

		filename = synonym('_filename', descriptor=filename)
		movieid = synonym('_movieid', descriptor=movieid)
		filepath = synonym('_filepath', descriptor=filepath)
		id = synonym('_id', descriptor=id)

		def __init__(self, filename, filepath, movieid):
			self._filename = filename
			self._filepath = filepath
			self._movieid = movieid

		def __repr__(self):
			return "<Fileinfo('%s','%s', '%s')>" % (self.filename, self.filepath, self.movieid)

