# -*- coding: UTF-8 -*-

__revision__ = '$Id: ge_mark_seen.py 1568 2011-08-10 20:08:12Z James Miller $'

# Copyright © 2011 Piotr Ożarowski
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published byp
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

# You may use and distribute this software under the terms of the
# GNU General Public License, version 2 or later

import logging
import gtk
from sqlalchemy.sql import update, insert

from db.tables import movies as movies_table
from gutils import question
from plugins.extensions import GriffithExtensionBase as Base
from sql import update_whereclause

log = logging.getLogger('Griffith')

class GriffithExtension(Base):
    name = 'Mark as seen2'
    description = _('Marks all currently filtered movies as seen2')
    author = 'Piotr Ożarowski'
    email = 'piotr@griffith.cc'
    version = 0.1
    api = 1
    enabled = False # disabled by default

    toolbar_icon = 'ge_mark_seen.png'

    def _on_toolbar_icon_clicked(self, widget):
	self.session = self.db.Session()
	if self.app.widgets['treeview'].get_selection().count_selected_rows() > 0:
	    for i in self.app.widgets['treeview'].get_selection().get_selected_rows()[1]:
		self.app.treemodel[i[0]][6] = not self.app.treemodel[i[0]][6]
		self.session.execute(movies_table.update().where(movies_table.c.movie_id==self.app.treemodel[i[0]][0]).values(seen=self.app.treemodel[i[0]][6]))
	else:
	    self.app.widgets['treeview'].set_model(None)
	    self.app.treemodel.foreach(self.row_update, 6)
	    self.app.widgets['treeview'].set_model(self.app.treemodel)
	self.session.commit()
	self.app.count_statusbar()

    def row_update(self, model, path, iter, user_data):
	if path:
	    model[iter][user_data] = not model[iter][user_data]
	    self.session.execute(movies_table.update().where(movies_table.c.movie_id==model[iter][0]).values(seen=model[iter][user_data]))
